/*
 * This code is part of the programming language flup
 * flup comes with ABSOLUTELY NO WARRANTY and is licensed under AGPL-3.0 or later.
 *    Copyright (C) 2024  VegOwOtenks
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#ifndef FLUP_FUNCTION_H
#define FLUP_FUNCTION_H

#include <stdlib.h>
#include "StringView/StringView.h"

typedef struct FlupFunctionAlternative_s {
	size_t condition_token_start;
	size_t condition_token_end;
	size_t body_token_start;
	size_t body_token_end;
	struct FlupFunctionAlternative_s* next;
} FlupFunctionAlternative;

typedef struct ParameterDefinition_s {
	StringView type;
	StringView name;
	struct ParameterDefinition_s* next;
} ParameterDefinition;

typedef struct FlupFunction_s {
	StringView name;
	ParameterDefinition* parameters;
	StringView return_type;
	FlupFunctionAlternative* alternatives;
	struct FlupFunction_s* next;
} FlupFunction;

#endif