/*
 * This code is part of the programming language flup
 * flup comes with ABSOLUTELY NO WARRANTY and is licensed under AGPL-3.0 or later.
 *    Copyright (C) 2024  VegOwOtenks
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#ifndef FLUP_VALUE_H
#define FLUP_VALUE_H

#include <stdint.h>
#include <stdbool.h>
#include "StringView/StringView.h"

enum ValueType {
	VALUETYPE_INT64,
	VALUETYPE_DOUBLE,
	VALUETYPE_BOOLEAN,
};

union ValueContent {
	int64_t i64;
	double  f64;
	bool    boolean;
};

typedef struct Value_s {
	enum ValueType type;
	union ValueContent get;
} Value;

bool Value_IsTruthy(Value* v);
bool Value_Equal(Value* v1, Value* v2);
bool Value_TypeMatchesStringName(enum ValueType type, StringView type_name);


#endif
